//<c>   Copyright 1995-1998 by Gerry J. Danen; all rights reserved.

//<t>   Batch program: goto row/col using ANSI.SYS,
//      and display text like DOS' echo.

#include"gd_tools.h"
#include"gd_ansi.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Echo @ Row/Col using ANSI.SYS"
#define pgCOPR_ "1995"


#define ESC     0x1B
UCHAR   cmdline[1024], p1[81], p2[81], p3[81] ;


void    help( void )
{
    logon(1);
    printf( "\nSyntax:\n\n%s row column [/cls] [/eos] [text]\n\n"
            "row and column are required; text is optional\n\n"
            "/cls will clear the screen first,\n"
            "/eos will clear from the cursor to the end of the screen\n\n"
            "ansi codes may be used in the [text] part to set text colours\n\n",
            get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    main( void )
{
    BOOL        ynCls=FALSE, ynEos=FALSE ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    CmdLine( cmdline );                         // get the command line
    st_trim( cmdline );
    if ( ! strlen( cmdline ) )
        help();

    st_get_word( p1, cmdline );                 // get first word in string
    st_remove_word( cmdline );                  // remove first word in string
    st_get_word( p2, cmdline );                 // get second word
    st_remove_word( cmdline );                  // remove second word

checkit:
    st_get_word( p3, cmdline );                 // get possible parameter
    strupr( p3 );
    if ( p3[0] == '/' && (strlen(p3) == 4) )    // /cls or /eos ?
    {
        if ( p3[1] == 'C' &&
             p3[2] == 'L' &&
             p3[3] == 'S' )
        {
            ynCls = TRUE ;
            st_remove_word( cmdline );          // remove parameter
            goto checkit ;
        }
        if ( p3[1] == 'E' &&
             p3[2] == 'O' &&
             p3[3] == 'S' )
        {
            ynEos = TRUE ;
            st_remove_word( cmdline );          // remove parameter
            goto checkit ;
        }
    }

    if ( ynCls )                                // clear screen
        ansi_cls( 0, stdout );

    if ( ynEos )                                // clear to end of screen
    {
        int x, row ;
        row = 1 + atoi( p1 );
        LOOP( x, row, 25, 1 )
        {
            ANSI_XYEOL(x,1);                    // clear line
        }
        row = atoi( p1 );
        x   = atoi( p2 );
        ANSI_XYEOL(row,x);                      // clear to end of current line
    }

    printf( "%c[%s;%sH", ESC, p1, p2 );         // position cursor

    printf( "%s", cmdline );                    // print text
}
